unit sStruct;

interface
uses hex,sDisks,sLink,gr4txt,timer;

{ Init    init }
procedure Init;

{      ப }
function TestKey(const key:char):byte;

{ 頥 㬥   }
function ArgKey(const n:byte):byte;

implementation
procedure SearchDrive;
var wk:byte; cnt:byte;
begin
wk:=TestKey('d'); cnt:=0;
if wk<>0 then
  begin
    Drive:=ArgKey(wk);
    if TestDriver then exit;
    writeln('No "Sevilija.sys" for device # ',Drive,' in memory.');
  end
 else
  begin
    for Drive:=0 to 255 do
      if TestDriver then
	begin
	  inc(cnt);
	  Writeln('Found "Sevilija.sys" for device # ',Drive,'.');
	  wk:=Drive;
	end;
    case cnt of
    0: Writeln('no "Sevilija.sys" in memory.');
    1: begin Drive:=wk; TestDriver; exit end;
    else
      writeln('Found ',cnt,' drivers. What device use ?');
    end;
  end;
halt(4);
end;

function TD_Convert(time:longint):string;
var THour,TMin,TSec,TTic:word; sh,sm,ss,st:string[3];
begin
str(time div 65543:2,sh); time:=(time mod 65543) * 10;
str(time div 10924:2,sm); time:=time mod 10924;
str(time div   182:2,ss);
str(time mod 182 div 10:2,st);
TD_Convert:=sh+':'+sm+':'+ss+'.'+st;
end;

procedure LogView;
var n:word;

begin
write('-- ୠ ᮢ $'); PointerOut(paLogRec); writeln(' --');
if pDriveData^.LenLog=0 then
  writeln('  ୠ   :((  稪 /b  Sevilija.sys...')
 else
  for n:=1 to pDriveData^.LenLog div sizeof(tLogRec) do
    with paLogRec^[n] do
      begin
	write(n:3,'. ',TD_Convert(ltime),', ',chr(lUnit+pDriveData^.StartDev+65),': ');
	case lReq of
	 1: write('Change Media ?');
	 2: write('Get BPB');
	13: write('Open');
	14: write('Close');
	15: write('Removeble ?');
	 4: write('Read : ',lFrSec,'..',lFrSec+lNmSec-1,' (',lNmSec,')');
	 8: write('Write: ',lFrSec,'..',lFrSec+lNmSec-1,' (',lNmSec,')');
	 else
	  write('req = ',lReq);
	end;
	writeln;
      end;
Writeln;
end;

procedure ComView;
var n:byte;
begin
with pDriveData^ do
  begin
    Write('-- 騥 ࠬ ࠩ $'); PointerOut(pDriveData); writeln(' --');
    writeln('ᥣ ன:            ',NumberDev);
    write  ('ন 㪢:       ');
      for n:=1 to NumberDev do
	write(chr(n-1+StartDev+65),': ');
      writeln;
    writeln(' ᯮ㥬 : ',Drive);
    write  (' 㯠  ன:   ');
      if DirectAcc=0 then writeln('१ BIOS') else begin
	write(' BIOS (');
	if Direct32=0 then write('16') else write('32');
	writeln('- )');
      end;
    write  ('᫥  RWTS:      ');
      case LastReq of
      0: writeln('  뫮');
      1: writeln('⥭');
      2: writeln('');
      else
	writeln('?');
      end;
    writeln(' ୠ:             ',LenLog div sizeof(tLogRec),' ᥩ');
    writeln('᫥ 窠 ୠ:    ',MrkLog div sizeof(tLogRec),' ');
    write('  ᨢ ⠡ ࠩ:                  $'); PointerOut(paDskHd); writeln;
    write('   ᫥ 襭 ࠩ: $'); PointerOut(Ptr(DriveSeg,DskCurHdAdr)); writeln;
    writeln;
  end;
end;

procedure LastRView;
begin
with pDriveData^ do
  begin
    Writeln('-- ࠬ ᫥  --');
    writeln(' ⠡ (16): ',tbl_Adr);
    writeln('稪 (0..127):   ',tbl_AdrCount);
    write  (':              $'); PointerOut(tbl_AdrAdress); writeln;
    writeln('Start:              ',tbl_AdrStartL);
    Writeln;
  end;
end;

procedure DskView;
var n,b:byte; Fin:LongInt; From:tRngPart; Att:string;
begin
write('--  ⥫ ࠩ $'); PointerOut(paDskHd); writeln(' --');
ClearDesc(PartDesc); From:=Low(tRngPart);
with pDriveData^ do begin
  for n:=1 to NumberDev do
    with paDskHd^[n] do begin
      with PartDesc[From] do begin
	Name:=chr(n-1+StartDev+65)+':';
	Start:=sDskSt; Fin:=sDskFn;
      end; inc(From);

      write(chr(n-1+StartDev+65),':  '); ViewFlags(sDskFlag);
      writeln('  OF =',sDskFile:4,', Area:',sDskSt:9,'..',sDskFn,' (',sDskFn-sDskSt,' = ', (sDskFn-sDskSt) div 2048,' Mb)');
      if sDskFlag and $0004 <> 0 then Att:='  :' else Att:='';
      if sDskFlag and $000C = $000C then
	writeln('    ० (NW) !');

      if TestPart(sDskSt,sLink.Drive,Fin) then
	begin
	  if Fin<>sDskFn then
	    writeln(ATT,'   ᪠  Boot Record (',Fin,')  ᮢ  .');
	end
       else
	writeln(ATT,'  ୠ ᨣ Boot Record.');

      for b:=1 to NumberDev do
	if (b<>n) and (
	  ((paDskHd^[b].sDskSt >= sDskSt) and (paDskHd^[b].sDskSt <= sDskFn)) or
	  ((paDskHd^[b].sDskFn >= sDskSt) and (paDskHd^[b].sDskFn <= sDskFn)) or
	  ((paDskHd^[b].sDskSt <= sDskSt) and (paDskHd^[b].sDskFn >= sDskFn))
	  ) then writeln(ATT,'  ४⨥ ࠩ  ',chr(b-1+StartDev+65),': !');
    end;
end;
Writeln;
end;

procedure GrapView;
label Done;
var n,st,len:word; MinTime,MaxTime:longint;

procedure Disp(const op1,op2,z,line:byte; s:string);
var
scr:array[0..GetMaxX] of LongInt;
b0,b1:byte; rate:extended; smax,sall,sspd:string[10]; All,MaxSect:LongInt;

begin
if MaxTime=MinTime then exit;
for b0:=0 to GetMaxX do scr[b0]:=0;
n:=st+1; rate:=GetMaxX/(MaxTime-MinTime); All:=0;

repeat   {    뫮, 稭   st+1 ?    1  len ? }
  with paLogRec^[n] do
    if (lReq=op1) or (lReq=op2) then
      begin
	inc(All,lNmSec);
	{$R-}
	b0:=round(rate*(lTime-MinTime));
	{$R}
	scr[b0]:=scr[b0]+lNmSec;
      end;
  if n>=len then n:=1 else inc(n);
until n=st+1;

PutPixel(1,1,z); PutPixel(2,2,z);
for b0:=0 to GetMaxY do PutPixel(0,b0,z);
PutPixel(GetMaxX-2,GetMaxY-2,z); PutPixel(GetMaxX-1,GetMaxY-1,z);

MaxSect:=0;
for b0:=0 to GetMaxX do
  if MaxSect<scr[b0] then MaxSect:=scr[b0];

if MaxSect<>0 then
  for b0:=0 to GetMaxX do
    for b1:=GetMaxY downto GetMaxY-round(scr[b0]/MaxSect*GetMaxY) do
      putpixel(b0,b1,z);

str(MaxSect/2:10:2,smax);
str(All/2:10:2,sall);
if MaxTime=MinTime then sspd:=' <unknow> ' else str( (All / 2) * 18.2 / (MaxTime-MinTime) :10:2,sspd);
DirWrite(1,line,s+': Max: '+smax+' Kb, All: '+sall+' Kb, Flow: '+sspd+' Kb/s');
end;

begin
with pDriveData^ do
  if LenLog=0 then
    writeln('  ୠ   :((  稪 /b  Sevilija.sys...')
   else
    begin
      SetGraphMode;
      repeat
	st:=MrkLog div sizeof(tLogRec); len:=LenLog div sizeof(tLogRec);

	if st<>0 then
	  begin
	    MinTime:=paLogRec^[st+1].lTime;
	    MaxTime:=paLogRec^[st+0].lTime;
	  end
	 else
	  begin
	    MinTime:=paLogRec^[1].lTime;
	    MaxTime:=paLogRec^[len].lTime;
	  end;

	DirWrite(1,23,'६: '+TD_Convert(MinTime)+' - '+TD_Convert(MaxTime)+'     ');
	ClearDevice;
	Disp(4,4,0,24,'⥭');
	Disp(8,9,1,25,'');
	WaitVSync; UpDateDevice;

	asm mov ah,$11 ; int $16 ; jnz Done end;
      until false;
      Done:
      asm mov ah,$10 ; int $16 end;
    end;
end;

procedure UnitsTune;
var n,un,j,k:byte; s,sSt,sFn,sMd:string; i:integer; c:char;

begin
with pDriveData^ do begin
  for n:=1 to ParamCount do begin
    s:=ParamStr(n); s[1]:=UpCase(s[1]);
    if length(s)>2 then begin
      if (s[2]=':') or (s[3]=':') then begin
	un:=0;
	if s[1] in ['0'..'9'] then begin
	  if s[2] in ['0'..'9'] then val(copy(s,1,2),un,i) else un:=ord(s[1])-ord('0');
	end;
	{$R-}
	if s[1] in ['A'..'Z'] then un:=ord(s[1])-ord('A')-StartDev;
	{$R+}
	if un>=NumberDev then continue;
	delete(s,1,pos(':',s));
	with paDskHd^[un+1] do begin
	  sDskFlag:=sDskFlag or 1;
	  j:=1;
	  while (j<=length(s)) and not (s[j] in [':','~','=']) do inc(j);
	  sMd:=copy(s,1,j-1);
	  if j<Length(s) then begin
	    c:=s[j]; delete(s,1,j);
	    case c of
	    '~': if s='?' then
		   DescSelect(LibrDesc,sDskSt,sDskFn)
		  else
		   for k:=Low(tRngPart) to High(tRngPart) do
		     with LibrDesc[k] do
		       if Name=s then begin
			 sDskSt:=Start; sDskFn:=Fin;
			 sDskFlag:=Str2Flags(Mode,sMd);
		       end;
	    '=': begin
		   ListPart(Drive);
		   if s='?' then
		     DescSelect(PartDesc,sDskSt,sDskFn)
		    else
		     begin
		       Val(s,k,i);
		       with PartDesc[Low(tRngPart)+k] do
			 begin sDskSt:=Start; sDskFn:=Fin end;
		       sDskFlag:=Str2Flags(sDskFlag,sMd);
		     end;
		 end;
	    ':': begin
		   k:=pos('-',s);
		   if k<>0 then begin
		     sSt:=copy(s,1,k-1);
		     sFn:=copy(s,k+1,255);
		     if sSt<>'' then val(sSt,sDskSt,i);
		     if sFn<>'' then
		       if sFn='*' then
			 TestPart(sDskSt,Drive,sDskFn)
			else
			 val(sFn,sDskFn,i);
		   end;
		   sDskFlag:=Str2Flags(sDskFlag,sMd);
		 end;
	    end;
	  end else begin
	    sDskFlag:=Str2Flags(sDskFlag,sMd);
	  end;
	end;
      end;
    end;
  end;
end;
end;

function TestKey;
var i:byte; s:string[2];
begin
for i:=1 to ParamCount do
  begin
    s:=ParamStr(i);
    if (s[1]='/') and (s[2]=key) then
      begin TestKey:=i; exit end;
  end;
TestKey:=0;
end;

function ArgKey;
var i:byte; c:integer;
begin
val(copy(ParamStr(n),3,255),i,c);
if c<>0 then
  begin
    writeln('宩 㬥  "',ParamStr(n),'".');
    halt(5);
  end
 else
  ArgKey:=i;
end;

procedure Init;
var wk,n:byte; s:string;
begin
if TestKey('?')<>0 then
  begin
    writeln('<unit|letter> : [r|R][W|w][N|n] [=PT_NUM | :[FROM]-[TO|*] | ~NAME]');
    writeln('/g -  䨪 ᮢ;');
    writeln('/l - 뢮  ᮢ;');
    writeln('/p - 뢠 䨣-䠩 ଠ樥  Partition Table;');
    writeln('/c - 뢠 䨣-䠩 ଠ樥  㦥 ࠩ;');
    writeln('/y - 뢮 ७ ࠬ;');
    writeln('/z - 뢮 ࠬ ᫥ ;');
    writeln('/q -  뢮 ࠬ஢ ⮢;');
    writeln('/? - 뢮  ⥪;');
    writeln('/i - ଠ  ࠧ   ࠧ 筨;');
    writeln('/m - ⠭ ० 㯠: /mb - BIOS, /md - Direct16, /m3 - Direct32;');
    writeln('/h - ⠭  HDD, ᯮ㥬 㦥 ࠩ஬;');
    writeln('/d - ⠭,   㤥   ࠢ஬, 㦨騬');
    writeln('     㪠 HDD.');
    halt;
  end;

SearchDrive; writeln;

wk:=TestKey('h');
if wk<>0 then
  with pDriveData^ do
    begin
      pDriveData^.Drive:=ArgKey(wk);
      for n:=1 to NumberDev do
	paDskHd^[n].sDskFlag:=1;
    end;

if TestKey('l')<>0 then LogView;

n:=TestKey('m'); if n<>0 then begin
  s[3]:=#0; s:=ParamStr(n);
  with pDriveData^ do case s[3] of
    'b': DirectAcc:=0;
    'd': begin DirectAcc:=1; Direct32:=0 end;
    '3': begin DirectAcc:=1; Direct32:=1 end;
   else
    begin
      writeln('宩 㬥  "',ParamStr(n),'".');
      halt(6);
    end;
  end;
end;
if TestKey('y')<>0 then ComView;

if TestKey('z')<>0 then LastRView;

if TestKey('i')<>0 then begin
  sdAccess:=0; SizeAssympt(Drive);
  sdAccess:=1; SizeAssympt(Drive);
  SizeFromHard(Drive);
  SizeFromBIOS(Drive);
  Halt;
end;

sdAccess:=pDriveData^.DirectAcc;

sDisks.Init; LoadDesc; UnitsTune;

if TestKey('c')<>0 then begin
  DskView; AppendDesc;
end else if TestKey('q')=0 then DskView;

if TestKey('p')<>0 then begin ListPart(Drive); AppendDesc; end;

if TestKey('g')<>0 then GrapView;
end;

end.